// This file was generated by qtwaylandscanner
// source file is ../protocol/dde-shell.xml

#ifndef QT_WAYLAND_SERVER_DDE_SHELL
#define QT_WAYLAND_SERVER_DDE_SHELL

#include "wayland-server-core.h"
#include "wayland-dde-shell-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  dde_surface_manager
    {
    public:
        dde_surface_manager(struct ::wl_client *client, int id, int version);
        dde_surface_manager(struct ::wl_display *display, int version);
        dde_surface_manager(struct ::wl_resource *resource);
        dde_surface_manager();

        virtual ~dde_surface_manager();

        class Resource
        {
        public:
            Resource() : dde_surface_manager_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            dde_surface_manager *dde_surface_manager_object;
            dde_surface_manager *object() { return dde_surface_manager_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


    protected:
        virtual Resource *dde_surface_manager_allocate();

        virtual void dde_surface_manager_bind_resource(Resource *resource);
        virtual void dde_surface_manager_destroy_resource(Resource *resource);

        virtual void dde_surface_manager_get_surface(Resource *resource, uint32_t id, struct ::wl_resource *surface);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::dde_surface_manager_interface m_dde_surface_manager_interface;

        static void handle_get_surface(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            struct ::wl_resource *surface);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            dde_surface_manager *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  dde_shell_surface
    {
    public:
        dde_shell_surface(struct ::wl_client *client, int id, int version);
        dde_shell_surface(struct ::wl_display *display, int version);
        dde_shell_surface(struct ::wl_resource *resource);
        dde_shell_surface();

        virtual ~dde_shell_surface();

        class Resource
        {
        public:
            Resource() : dde_shell_surface_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            dde_shell_surface *dde_shell_surface_object;
            dde_shell_surface *object() { return dde_shell_surface_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_geometry(int32_t x, int32_t y, int32_t w, int32_t h);
        void send_geometry(struct ::wl_resource *resource, int32_t x, int32_t y, int32_t w, int32_t h);
        void send_property(const QString &name, const QByteArray &value);
        void send_property(struct ::wl_resource *resource, const QString &name, const QByteArray &value);

    protected:
        virtual Resource *dde_shell_surface_allocate();

        virtual void dde_shell_surface_bind_resource(Resource *resource);
        virtual void dde_shell_surface_destroy_resource(Resource *resource);

        virtual void dde_shell_surface_get_geometry(Resource *resource);
        virtual void dde_shell_surface_set_property(Resource *resource, const QString &name, wl_array *value);
        virtual void dde_shell_surface_get_property(Resource *resource, const QString &name);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::dde_shell_surface_interface m_dde_shell_surface_interface;

        static void handle_get_geometry(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_set_property(
            ::wl_client *client,
            struct wl_resource *resource,
            const char *name,
            wl_array *value);
        static void handle_get_property(
            ::wl_client *client,
            struct wl_resource *resource,
            const char *name);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            dde_shell_surface *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
